Description

Gennadiy and Ron reported that when using many buffers (O(1000)) in the SBND system, the performance was actually worse than
when using O(100) buffers. This is mostly likely due to inefficiencies in SharedMemoryManager.

History

#1 - 03/20/2019 12:37 PM - Eric Flumerfelt
- Assignee set to Eric Flumerfelt
- Status changed from New to Resolved

- Category set to Additional Functionality

| have made a small set of improvements in artdaqg-core:feature/22159_SMM_ManyBufferimprovements and
artadqg:feature/22159_SMEM_Performancelmprovements using profile-guided optimization.

| was specifically targeting the SBND case where O(1 kHz) of O(100 KB) Fragments was desired. The changes on the artdag-core branch, in
particular, drastically improve performance when using many (>=1000) shared memory buffers.

#2 - 11/01/2019 01:34 PM - John Freeman
- File driver_test20000.fcl added

- File driver_test2000.fcl added

- File driver_test200.fcl added

I've performed comparisons of artdag-core and artdaq at the head of their develop branches (2c73f1ce0d9e66eabe7c302b1fd563ec73beb61a and
8d9c7a305666b65d22dfecaf557f1e2e3c8009d4, respectively) versus at the head of artdag-core's feature/22159_SMM_ManyBufferimprovements
branch (16589d86080ba8769613d324a51a81dd74372523) and the head of artdaq's feature/22159_SMEM_Performancelmprovements branch
(210ac95358a329¢2939ab760a4f3204ec76757¢2 ). Some results.

First, for artdagDriver: taking Eric's original test FHiCL documents, but reducing the events processed from 1M to 100k (and attached as files to this
Issue), | found the following for the develop branches:

driver_test200.fcl (buffer_count 200):
real0m19.130s

userOm24.206s

sysOm2.222s

driver_test2000.fcl (buffer_count 2000):
real0m52.138s

userim22.932s

sysOm3.085s

driver_test20000.fcl (buffer_count 20000):
real7m9.167s

user12m10.183s

sysOm10.494s

...in other words, things slowed down drastically with a higher buffer count. And then, if | go to the feature branches:
driver_test200.fcl (buffer_count 200):
realOm16.127s

userOm17.897s
sysOm1.638s
driver_test2000.fcl (buffer_count 2000):
realim4.124s

userim20.900s

sysOm3.345s

driver_test20000.fcl (buffer_count 20000):
real0m49.137s

userimi1.282s

sysOm4.669s

...what | see is that while performance is pretty similar for a buffer count of 200 and 2000, it's drastically better for a buffer count of 20000.

To generate a slightly messier, more real-world scenario, | also performed runs of 60 seconds each using different buffer counts in the eventbuilder
(but not the datalogger), with two toy simulators running in push mode with no built-in pauses (throttle_usecs and usecs_between_sends both set to

0). Here's what | found:

Develop branches:

Run buffer_count events
3078 200 129996
3079 600 117075
3080 1000 88646
3081 2000 57865
3082 10000 16452
Feature branches:
Run buffer_count events
3073 200 136342
3074 600 129826
3075 1000 122304
3076 2000 74467
3077 10000 29153

Where | should point out that (A) as always for my tests, the run records can be found in /home/jcfree/run_records, and (B) | used only 10 ADC counts
per event, rather than the hundreds-of-thousands in the driver*.fcl scripts. As you can see, while in both cases performance degraded considerably

with higher buffer counts, the degradation was significantly less severe using the feature branches than using the develop branches.

#3 - 11/04/2019 09:26 AM - John Freeman
- % Done changed from 0 to 100

- Status changed from Resolved to Reviewed

Eric's happy, I'm happy, and this issue is reviewed.

#4 - 11/21/2019 02:35 PM - Eric Flumerfelt

- Status changed from Reviewed to Closed

#5 - 11/21/2019 02:35 PM - Eric Flumerfelt

- Target version set to artdaq_core v3_05_09

Files

driver_test2000.fcl 1.93 KB 11/01/2019 John Freeman
driver_test200.fcl 1.93 KB 11/01/2019 John Freeman
driver_test20000.fcl 1.93 KB 11/01/2019 John Freeman
